#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "modbus.h"

#if 0

#define CHECK if (!l) \
{ \
	printf ("FAILED\n"); \
	return EXIT_FAILURE; \
} \
else printf ("OK\n")

struct data_elem
{
	char *s;
	int nr;
};

void print_data (list *l)
{
	struct data_elem *tmp;
	
	printf ("print data: ");
	tmp = (struct data_elem *) get_element_data (l);
	if (!tmp)
	{
		printf ("FAILED\n");
		exit (EXIT_FAILURE);
	}
	
	printf ("data->nr = %d\n", tmp->nr);
}

int main (void)
{
	int i;
	list *l;
	struct data_elem data;
	char *data_str = "0123456789abcdef";
	
	data.s = data_str;
	data.nr = 0;
	
	printf ("Init List: ");
	l = init_list ((void *) &data, sizeof (data));
	
	CHECK;
	
	printf ("Add 9999 Entrys: ");
	for (i = 1; i < 10000; i++)
	{
		data.nr = i;
		l = add_to_list (l, (void *) &data, sizeof (data));
		if (!l) break;
	}
	
	CHECK;
	
	printf ("goto head: ");
	l = goto_head (l);
	CHECK;
		
	print_data (l);

	printf ("print next 5:\n");
	for (i = 0; i < 5; i++)
	{
		l = goto_next (l);
		print_data (l);
	}
	
	printf ("goto tail: ");
	l = goto_tail (l);
	CHECK;
	
	print_data (l);
	
	printf ("print prev 5:\n");
	for (i = 0; i < 5; i++)
	{
		l = goto_prev (l);
		print_data (l);
	}
		
	printf ("Free List: ");
	
	del_list (l);
	
	printf ("OK\n");
	
	return EXIT_SUCCESS;
}

#endif

int main (int argc, char *argv[])
{
	modbus_dev_t dev;

	printf ("binding to modbus device...");
	if (modbus_bind (&dev, "192.168.23.108", 502) == -1) {
		printf ("error!\n");
		exit (1);
	}
	printf ("done. \n");

	printf ("writing coils...");
	while (1) {
		modbus_w_single_coil (&dev, 0, 1);
		usleep (100000);
		modbus_w_single_coil (&dev, 0, 0);
		modbus_w_single_coil (&dev, 1, 1);
		usleep (100000);
		modbus_w_single_coil (&dev, 1, 0);
		modbus_w_single_coil (&dev, 2, 1);
		usleep (100000);
		modbus_w_single_coil (&dev, 2, 0);
		modbus_w_single_coil (&dev, 3, 1);
		usleep (100000);
		modbus_w_single_coil (&dev, 3, 0);
		modbus_w_single_coil (&dev, 4, 1);
		usleep (100000);
		modbus_w_single_coil (&dev, 4, 0);
		modbus_w_single_coil (&dev, 5, 1);
		usleep (100000);
		modbus_w_single_coil (&dev, 5, 0);
	}
		
	printf ("done.\n");
	
	printf ("unbinding from modbus device...");
	if (modbus_unbind (&dev) == -1) {
		printf ("error!\n");
		exit (1);
	}
	printf ("done.\n");
		
	return 0;
}
